/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core/ES5/DVContainer";
import { Type, runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType } from "igniteui-react-core/ES5/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { TrendLineType_$type } from "igniteui-react-core/ES5/TrendLineType";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
/**
 * @hidden
 */
var HorizontalAnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(HorizontalAnchoredCategorySeries, _super);
    function HorizontalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pv = null;
        _this.pr = null;
        _this.px = null;
        _this.pt = 0;
        return _this;
    }
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "pw", {
        get: function () {
            var _this = this;
            if (this.pv == null) {
                this.pv = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.pv;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.prototype.hn = function () {
        _super.prototype.hn.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalAnchoredCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    HorizontalAnchoredCategorySeries.prototype.mz = function () {
        return this.pr;
    };
    HorizontalAnchoredCategorySeries.prototype.nj = function () {
        return this.px;
    };
    HorizontalAnchoredCategorySeries.prototype.lp = function (a) {
        if (this.m0 == null || this.m0.m.count == 0 || !this.hasMarkers || !this.lw()) {
            return Rect.empty;
        }
        return this.pw.d$d(this, this.m0.m, a, runOn(this, this.p9));
    };
    HorizontalAnchoredCategorySeries.prototype.p9 = function (a) {
        return this.or.c5(a);
    };
    HorizontalAnchoredCategorySeries.prototype.p1 = function (a, b, c) {
        return this.pw.d$c(this, this.nj(), a, b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.ah = function (a) {
        return this.pw.d$a(this, this.m0.f, this.n0(this.bi), this.n1(this.bi), a);
    };
    HorizontalAnchoredCategorySeries.prototype.ai = function (a) {
        return this.pw.d$b(this, this.m0.f, this.n0(this.bi), this.n1(this.bi), a);
    };
    HorizontalAnchoredCategorySeries.prototype.dg = function (a, b) {
        if (this.df(a, b)) {
            return true;
        }
        if (this.lx(a, b)) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.m4.r(this.mz(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var a = this.getEffectiveViewport1(this.bi);
        return this.mz().getCategorySize(this.bi.bs, this.bi.br, a);
    };
    HorizontalAnchoredCategorySeries.prototype.ek = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.mz();
        var f = new ScalerParams(0, this.bs.mq, this.bi.br, e.b8, d);
        var g = this.m4.r(e, this.bs.mq, this.bi.br, d);
        return this.em(this.valueColumn, a, e, f, g, runOn(this, this.ny), b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.fb = function (a, b) {
        return this.fc(a, b, this.mz(), runOn(this, this.ny), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.e9 = function (a, b) {
        return this.fa(a, b, this.mz(), runOn(this, this.ny), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.d6 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d7(a, b, this.mz(), d, e, this.valueColumn.count, runOn(this, this.ny));
    };
    HorizontalAnchoredCategorySeries.prototype.le = function (a, b, c) {
        if (this.mz() == null || this.nj() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.lg(a, b, c, this.m4.r(this.mz(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.nj(), this.mz(), null, null, null);
    };
    HorizontalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.pr;
    };
    HorizontalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.px;
    };
    HorizontalAnchoredCategorySeries.prototype.o9 = function (a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.pa = function (a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.nu = function () {
        return this.px != null && this.px.ck();
    };
    HorizontalAnchoredCategorySeries.prototype.p5 = function (a) {
        this.pr = a;
    };
    HorizontalAnchoredCategorySeries.prototype.p6 = function (a) {
        this.px = a;
    };
    HorizontalAnchoredCategorySeries.prototype.mt = function (a, b) {
        return this.oo(a, b, this.pr);
    };
    HorizontalAnchoredCategorySeries.prototype.is = function (a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.p5(this.xAxis);
                if (this.or.cz) {
                    this.or.cy = CategoryTrendLineManagerFactory.a(this.or.cy, this.pr, this.jq, this, this.b2);
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.or.cy = CategoryTrendLineManagerFactory.a(this.or.cy, this.pr, this.jq, this, this.b2);
                }
                break;
        }
        _super.prototype.is.call(this, a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.ht(typeCast(Axis.$, c));
                    this.ix(typeCast(Axis.$, d));
                    this.p5(this.xAxis);
                    this.m8.cn.g(this.er);
                    this.i6(false);
                    this.ic();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.ht(typeCast(Axis.$, c));
                    this.ix(typeCast(Axis.$, d));
                    this.p6(this.yAxis);
                    this.m8.cn.g(this.er);
                    this.nu();
                    this.i6(false);
                    this.ic();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.kg(true);
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.hs = function (a, b, c, d) {
        _super.prototype.hs.call(this, a, b, c, d);
        if (this.pr != null && typeCast(ISortingAxis_$type, this.pr) !== null) {
            this.pr.i$i();
        }
        switch (a) {
            case 4:
                if (this.pr != null) {
                    this.pr.ck();
                }
                if (this.px != null && !this.px.ck()) {
                    this.i6(true);
                }
                break;
            case 1:
                if (this.pr != null) {
                    this.pr.ck();
                }
                if (this.px != null && !this.px.ck()) {
                    this.i6(true);
                }
                break;
            case 0:
                if (this.pr != null) {
                    this.pr.ck();
                }
                if (this.px != null && !this.px.ck()) {
                    this.i6(true);
                }
                break;
            case 2:
                if (this.o2 != null && this.or.cn.d > 0 && this.px != null && !this.px.ck()) {
                    this.i6(true);
                }
                break;
            case 3:
                if (d == this.o2) {
                    if (this.pr != null) {
                        this.pr.ck();
                    }
                    if (this.px != null && !this.px.ck()) {
                        this.i6(true);
                    }
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.pz = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.p0 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "pu", {
        get: function () {
            return this.pt;
        },
        set: function (a) {
            var b = this.pu;
            if (a != b) {
                this.pt = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.pu));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nv;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    return HorizontalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { HorizontalAnchoredCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::p7', [CategoryAxisBase.$, null], 'YAxis::p8', [NumericYAxis.$, null]]);
